class User < ActiveRecord::Base
  before_save :encrypt_password

  attr_accessible :account, :bank_account, :email, :encrypted_password, :username, :password, :password_confirmation, :profile_picture
  attr_accessor :password

  validates :username, :presence => true, :uniqueness => true
  validates :password, :confirmation => true, :if => :password_required?
  #validates :password_confirmation, :presence =>true

  has_many :bids
  has_many :events, :through => :bids
  
  def self.encrypt(pass,salt)
    Digest::SHA1.hexdigest(pass+salt)
  end
  
  def encrypt_password
    return if password.blank?
    if new_record?
      self.salt = Digest::SHA1.hexdigest(Time.now.to_s+email+username)
    end
    self.encrypted_password = User.encrypt(password,salt)
  end

  def self.authenticate(user,pass)
    u = find_by_username user
    # u = User.where(username:user)
    u && u.authenticated?(pass) ? u : nil
  end

  def authenticated?(pass)
    encrypted_password == User.encrypt(pass, salt)
  end

  def password_required?
    encrypted_password.blank? || !password.blank?
  end

  def save_file(upload)
    dir = Rails.root.join("public","profilepictures")
    if !File.exists? dir
      Dir.mkdir dir
    end
    fname = File.basename(upload[:file].original_filename)
    fname.gsub!(/^\w\.\_/,"_")
    path = File.join(dir,fname)
    File.open(path,"w") { |f| f.write(upload[:file].read) }
    self.profile_picture = fname
    save
  end
end
